***********************************
* Filer
* 3/6/95
* By Tony Fardella (tonyf@crl.com)
*
set escape off

on error do ShowError with listPath
set typeahead to 0
set exclusive off

*
* Check for ANSI terminal capabilities
*
if .not. uansi()
    do ChkANSI
endif

*
* Initialize our public variables
*

* Starting line # and Text postion
Public lOffset, txtCol, typeCol, sizeCol, dateCol, timeCol, tagCol

* Pointer to current record and total records
Public numRecs, curRec

* Current page line, total lines this page, maximum # or lines per page
Public curLine, pageLines, maxLines

* Current page number, total pages
Public pageNum, totalPages

Public ON, OFF, scrTitle, uQuit, dPath, eText, fileFilter, curPath
Public tagged, tagSize, do_it

*
* Set initial value of variables
*
lOffset 	= 4
maxLines	= 18
curLine 	= 1

tagCol      = 1
numCol      = 6
txtCol      = 8
typeCol     = 21
sizeCol     = 28
dateCol     = 40
timeCol     = 50

ON		= .T.
OFF 	= .F.
stext	= .T.
do_it   = .F.
fileFilter = "*.*"
tagged = 0
taggedSize = 0

*
* Make temporary database filenames based on unique line number
*
listdb = "LST"+ULINE()+".DBF"       && Contains current list of items
newstruc = "news"+ULINE()+".DBF"    && Template for creating listdb

*
* Create a template for the current list. We'll keep this one around since
* we will be using it many times. It will be deleted when the user quits
* the program.
*
create &newstruc
use &newstruc
append blank
replace field_name with "LTEXT", field_type with "C", field_len with 12
append blank
replace field_name with "LPATH", field_type with "C", field_len with 128
append blank
replace field_name with "LTYPE", field_type with "C", field_len with 6
append blank
replace field_name with "LTAG", field_type with "L", field_len with 1

*
* Read the OPTDATA and pull out the file path and optional flags
* If there is no file path in the OPT DATA then we assume "c:\*.*"
*
offset = at(chr(38)+chr(38), optdata())

if offset = 0
    dPath = "c:\*.*"
else
    dPath = trim(substr(optdata(), offset + 3))
endif

* Call GetDir to build our directory database
do GetDir with dPath

* Setup our initial variables for the display
do_display = .T.
do TopStatus
curLine = 1
pageNum = 0

*
* Main Event Loop - Handle User input
*
do while .t.

    * Draw the display if necessary
	if do_display
        do DrawList
		do Highlight with curLine, ON
		do_display = .F.
	endif

    key = 255
    key = inkey(0)

	*
    * Catch the function keys otherwise they cause problems
	*	F2 - F10 = (-1) - (-9)
	*
	if key < 0
        key = 255
	endif

    * Change the key code to a character for easier reading
    sel = upper(chr(key))
	do case

	*
	* Display the help screen on "?"
	*
	case sel = "?"
        do ShowHelp
        do_display = .T.

	*
	* Quit on Q
	*
    case sel = "Q" .or. key = 0
        uQuit = .F.
        do UserQuit
        if uQuit
            exit
        endif
        do_display = .T.

	*
	* Previous line on cursor up
	*
	case sel = chr(05)
        if curLine > 1
            do Highlight with curLine, OFF
            curLine = curLine - 1
            do Highlight with curLine, ON
        else
            if pageNum <> 0
                pageNum = pageNum - 1
                curLine = maxLines
                do_display = .T.
            endif
        endif

	*
	* Next line on cursor down
	*
	case sel = chr(24)
        if curLine < pageLines
            do Highlight with curLine, OFF
            curLine = curLine + 1
            do Highlight with curLine, ON
        else
            if recno() <> numRecs
                pageNum = pageNum + 1
                curLine = 1
                do_display = .T.
            endif
        endif

	*
	* Previous page on page up
	*
	case sel = chr(18)
        if pageNum > 0
            pageNum = pageNum - 1
            curLine = maxLines
            do_display = .T.
        endif

	*
	* Next page on page down
	*
	case sel = chr(3)
	   if pageNum < totalPages - 1
            pageNum = pageNum + 1
            curLine = 1
            do_display = .T.
        endif

	*
    * Download the selected item if it is a file or move to
    * the selected directory on Cursor Right or Return
	*
    case sel = chr(4) .or. sel = chr (13) .and. (.not. reccount()=0)
        if substr(LTYPE,2,1) = "X"
            do case
            case LTEXT = ".."
                dPath = substr(dPath, 1, rat("\", dPath) - 1)
                dpath = substr(dPath, 1, rat("\", dPath) - 1)
                do GetDir with dPath + "\*.*"
                pageNum = 0
                curLine = 1
                do_display = .T.

            otherwise
                do GetDir with rtrim(LPATH) + rtrim(LTEXT) + "\*.*"
                do_display = .T.

            endcase
        else
            if .not. substr(LTYPE,2,1) = "X" .and. .not. substr(LTYPE,5,1) = "X"
                dotbbs type 1 optdata rtrim(LPATH) + rtrim(LTEXT) + " /D/NBC/NB"

                * Re-open the workspace file
                use &listdb
                * and re-draw the list
                do TopStatus
                do_display = .T.
            endif
        endif

	*
    * Display previous directory, if there is one, on cursor left
	*
	case sel = chr(19)
        dPath = substr(dPath, 1, rat("\", dPath) - 1)
        dpath = substr(dPath, 1, rat("\", dPath) - 1)
        fileFilter = "*.*"
        do GetDir with dPath + "\" + fileFilter
        pageNum = 0
        curLine = 1
        do_display = .T.

	*
	* Download file if "D"
	*
    * If no files tagged then this command will download the currently selected
    * file. If files are tagged then any tagged files will be downloaded.
    *
	case sel = "D"
        if .not. substr(LTYPE,2,1) = "X" .and. .not. substr(LTYPE,5,1) = "X"
            @0,0 clear
            if tagged = 0
                dotbbs type 1 optdata rtrim(LPATH) + rtrim(LTEXT) + " /D/NBC/NB"
            else
                * Build the string with the opt data and tagged file names
                tList = ""
                set filter to LTAG
                go top
                do while .not. eof()
                   tList = tList + " " + rtrim(LTEXT)
                   skip
                enddo
                go top
                optStr = rtrim(LPATH) + ' /NL/I:"' + tList + '"'

                * Now tell TBBS to download the list of files
                dotbbs type 34 optdata optStr
            endif

            * Re-open the workspace file
            use &listdb
            * and re-draw the list
            do TopStatus
            do_display = .T.
        endif


    *
    * Upload file if "U"
    *
    * Does not allow files to be overwritten.
	*
    case sel = "U"
        @0,0 clear
        set color to GR+/N
        dotbbs type 28 optdata rtrim(LPATH)
        set color to W/N

        * Re-open the workspace file
        use &listdb
        * and re-draw the list
        do GetDir with rtrim(LPATH) + fileFilter
        do TopStatus
        do_display = .T.


    *
    * View archive file if "V"
	*
    case sel = "V"
        if .not. substr(LTYPE,2,1) = "X" .and. .not. substr(LTYPE,5,1) = "X"
            if tagged = 0
                optStr = rtrim(LPATH) + ' /NL/I:"E ' + LTEXT + '"'
                dotbbs type 34 optdata optStr
            else
                * Build the string with the opt data and tagged file names
                tList = ""
                set filter to LTAG
                go top
                do while .not. eof()
                   tList = tList + " " + rtrim(LTEXT)
                   skip
                enddo
                go top
                optStr = rtrim(LPATH) + ' /NL/I:"E' + tList + '"'

                * Now tell TBBS to download the list of files
                dotbbs type 34 optdata optStr
            endif

            wait "--< End of Archive. Press any key to continue. >--"

            * Re-open the workspace file
            use &listdb
            * and re-draw the list
            do TopStatus
            do_display = .T.
        endif


    *
    * Copy file on "C"
	*
    case sel = "C"
        if .not. substr(LTYPE,2,1) = "X" .and. .not. substr(LTYPE,5,1) = "X"
            do Box3D with  12,5,19,75,0
            set color to R/W
            @13,38 say "Copy"
            @15,8 say "Copy file:"
            set color to B/W
            @15,19 say rtrim(LTEXT)
            set color to R/W
            @17,14 say "<ENTER> Accept                       <ESC> Cancel"
            @16,8 say "To: "
            eText = ""
            do LineEdit with 16, 12, 70

            if .not. empty(eText)
                oldFile = rtrim(LPATH) + rtrim(LTEXT)
                
                * Fix-up the input string
                eText = ltrim(rtrim(eText))
                if rat("\",eText) = len(eText)
                    newFile = eText + LTEXT
                else
                    newFile = eText + "\" + LTEXT
                endif

                do_it = .T.
                if file(newFile)
                    do FileExist
                endif

                if do_it
                    copy file &oldFile to &newFile
                    do GetDir with rtrim(LPATH) + fileFilter
                endif
            endif

            set color to w/
            do_display = .T.
        endif
    *
    * Move file on "M"
	*
    case sel = "M"
        if .not. substr(LTYPE,2,1) = "X" .and. .not. substr(LTYPE,5,1) = "X"
            do Box3D with  12,5,19,75,0
            set color to R/W
            do Center with 13, "Move"
            @15,8 say "Move file:"
            set color to B/W
            @15,21 say rtrim(LTEXT)
            set color to B/W
            @17,14 say "<ENTER> Accept                       <ESC> Cancel"
            @16,8 say "To: "
            eText = ""
            do LineEdit with 16, 12, 70
            set color to w/
            if .not. empty(eText)
                oldFile = rTrim(LPATH) + rTrim(LTEXT)
                newFile = eText
                if .not. file(newFile)
                    rename &oldFile to &newFile
                    do GetDir with rtrim(LPATH) + fileFilter
                endif
            endif
            do_display = .T.
        endif

    *
    * Erase file on "E"
	*
    case sel = "E"
        if .not. substr(LTYPE,2,1) = "X" .and. .not. substr(LTYPE,5,1) = "X"
            do Box3D with  10,12,20,68,0
            set color to R/W
            do Center with 11, "Erase"
            @13,16 say "Erase file:"
            set color to B/W
            @13,28 say rtrim(LTEXT)
            set color to R+*/W
            do Center with 14, "WARNING !!"
            set color to GR+/W
            do Center with 15, "You are about to delete a file!"
            do Center with 16, "Are you sure you want to do this?"
            set color to B/W
            do Center with 18, "<ENTER> Accept                     <ESC> Cancel"
            key = inkey(0)
            if key = 13
                oldFile = rtrim(LPATH) + rtrim(LTEXT)
                erase &oldFile
            endif
            do GetDir with rtrim(LPATH) + fileFilter
            do_display = .T.
        endif

    *
	* Display the file information on "I"
	*
	case sel = "I"
        do GetInfo with rtrim(LPATH) + rtrim(LTEXT)
        do_display = .T.

	*
	* Jump to item number if user enters a number 1 - 9
	*
	case sel > "0" .and. sel < ":"
        do Box3D with  12,24,15,58,0
        set color to R/W,W+
        inNum = chr(lastkey())
        @13,27 say "Go to item #:      of " + ltrim(str(numRecs))
        do while .T.
            @13,41 say inNum + " "
            key = inkey(0)
            do case
            case key = 8 .or. key = 19       && Backspace
                inNum =left(inNum, len(inNum) - 1)
            case key > 47 .and. key < 58        && it's a number
                if len(inNum) <> 3
                inNum = inNum + chr(key)
                endif
            case key = 13
                exit
            case key = 0
                inNum = ""
                exit
            endcase
        enddo
        inNum = val(inNum)
        set color to w/
        if inNum <= numRecs .and. inNum > 0
            pageNum = int((inNum - 1) / maxLines)
            curLine = inNum - (pageNum * maxLines)
        endif
        do_display = .T.

	*
	* Goto the end of the list on "B"
	*
	case sel = "B"
        pageNum = int((numRecs - 1) / maxLines)
        curLine = numRecs - (pageNum * maxLines)
        do_display = .T.

	*
	* Goto the start of the list on "T"
	*
	case sel = "T"
        pageNum = 0
        curLine = 1
        do_display = .T.

    *
    * Tag the item on " "
	*
    case sel = " "
        if (.not. substr(LTYPE,2,1) = "X")  .and. (.not. substr(LTYPE,3,1) = "X")  .and. (.not. substr(LTYPE,4,1) = "X") .and. (.not. reccount() = 0)
            if LTAG
                replace LTAG with .F.
                @ lOffset + curLine, tagCol say " "
                if tagged > 0
                    tagged = tagged - 1
                    taggedSize = taggedSize - fsize(rtrim(LPATH) + rtrim(LTEXT))
                endif
            else
                replace LTAG with .T.
                set color to W+/
                @ lOffset + curLine, tagCol say "*"
                tagged = tagged + 1
                taggedSize = taggedSize + fsize(rtrim(LPATH) + rtrim(LTEXT))
            endif

            set color to R/W
            @2,25 say ltrim(str(tagged)) + "    "
            @2,37 say ltrim(str(taggedSize)) + "         "
            set color to w/
        endif

        * Highlight the next item in the list no matter what
        if curLine < pageLines
            do Highlight with curLine, OFF
            curLine = curLine + 1
            do Highlight with curLine, ON
        else
            if recno() <> numRecs
                pageNum = pageNum + 1
                curLine = 1
                do_display = .T.
            endif
        endif


    *
    * Filter on "F"
    *
    case sel = "F"
        do Box3D with  12,20,19,60,0
        set color to R/W
        do Center with 13, "File Filter"
        @15,24 say "Filter:"
        set color to B/W
        do Center with 17, "<ENTER> Accept       <ESC> Cancel"
        eText = "*.*"
        do LineEdit with 15, 32, 44
        if len(eText) > 0
            fileFilter = eText
            do GetDir with rtrim(curPath) + fileFilter
        endif
        set color to w/
        do_display = .T.

    endcase
enddo

*
* We're done so let's clean up our mess and leave
*
close all
fclose

if file(listdb)
   erase &listdb
endif
if file(newstruc)
	erase &newstruc
endif
quit

******************************************************************
* Program Procedures
*
* The following procedures are specific to the Filer program. Many, however
* could be easily modified for use in other programs.
*

****************************
Procedure DrawList
*
* Input: none
*
* Output: Display "maxLines" lines from a list on the screen
*
Private dRec, scLine

set color to R/W
@1,8 clear to 1,74
do Center with 1, scrTitle
set color to w/

@ 5,0 clear
scLine = 0

if reccount()=0
    set color to R/N
    do Center with 5,"<<< No Files Found >>>"
    set color to w/
    return
endif

dRec = (pageNum * maxLines) + 1
go dRec
do while (scLine < maxLines) .or. dRec = numRecs
	scLine = scLine + 1

    if LTAG
        set color to W+/
        @ lOffset + scLine,tagCol say "*"
    endif

    set color to GR+/
    itemNum = ltrim(str(dRec))
    colNum = 6 - len(itemNum)
    @ lOffset + scLine,colNum say itemNum + "."

	set color to W+/
    @lOffset + scLine,txtCol say rtrim(LTEXT)

    set color to BG/
	do case
    case substr(LTYPE,2,1) = "X"
		@lOffset + scLine,typeCol say "<DIR>"
	case substr(LTYPE,3,1) = "X"
		@lOffset + scLine,typeCol say "<VOL>"
	case substr(LTYPE,4,1) = "X"
		@lOffset + scLine,typeCol say "<SYS>"
	endcase

    if .not. substr(LTYPE,2,1) = "X"
        @lOffset + scLine,sizeCol say fsize(rtrim(LPATH) + rtrim(LTEXT))
        @lOffset + scLine,dateCol say fdate(rtrim(LPATH) + rtrim(LTEXT))
        @lOffset + scLine,timeCol say ftime(rtrim(LPATH) + rtrim(LTEXT))
    endif

	dRec = dRec + 1
	if dRec > numRecs
	exit
	endif
	skip
enddo
pageLines = scLine
do PageStatus
set color to R/W
@2,25 say ltrim(str(tagged)) + "  "
@2,37 say ltrim(str(taggedSize)) + "        "
return

***********************************
Procedure Highlight
Parameters nItem, state
*
* Set the highlight of the given item on or off
*
* Input: nItem = line number to work on
*	 state = ON  - highlight item
*		   = OFF - unhighlight item
*

if reccount()=0
    return
endif

go ((pageNum * maxLines) + nItem)

if state
    set color to N/W

    @lOffset + nItem, txtCol say rtrim(LTEXT)

    do case
	case substr(LTYPE,2,1) = "X"
		@lOffset + nItem,typeCol say "<DIR>"
	case substr(LTYPE,3,1) = "X"
		@lOffset + nItem,typeCol say "<VOL>"
	case substr(LTYPE,4,1) = "X"
		@lOffset + nItem,typeCol say "<SYS>"
	endcase

	if .not. substr(LTYPE,2,1) = "X"
        @lOffset + nItem,sizeCol say fsize(rtrim(LPATH) + rtrim(LTEXT))
        @lOffset + nItem,dateCol say fdate(rtrim(LPATH) + rtrim(LTEXT))
        @lOffset + nItem,timeCol say ftime(rtrim(LPATH) + rtrim(LTEXT))
    endif
else
	set color to W+/

    @ lOffset + nItem, txtCol say rtrim(LTEXT)

    set color to BG/
    do case
	case substr(LTYPE,2,1) = "X"
		@lOffset + nItem,typeCol say "<DIR>"
	case substr(LTYPE,3,1) = "X"
		@lOffset + nItem,typeCol say "<VOL>"
	case substr(LTYPE,4,1) = "X"
		@lOffset + nItem,typeCol say "<SYS>"
	endcase

	if .not. substr(LTYPE,2,1) = "X"
        @lOffset + nItem,sizeCol say fsize(rtrim(LPATH) + rtrim(LTEXT))
        @lOffset + nItem,dateCol say fdate(rtrim(LPATH) + rtrim(LTEXT))
        @lOffset + nItem,timeCol say ftime(rtrim(LPATH) + rtrim(LTEXT))
    endif

endif
set color to W/
return

********************************
Procedure TopStatus
*
* Draws the status box at the top of the screen
*
clear
do Box3D with 0,1,4,79,0
set color to R/W
@ 2,60 say "<Q>uit  <?> Help"
@ 2,20 say "Tag:       Size:"
do Center with 1, scrTitle
set color to W/
return

********************************
Procedure PageStatus
*
* Updates the page number in the status bar
*
set color to R/W
@ 2,4 say "Page " + ltrim(str(pageNum + 1)) + " of " + ltrim(str(ceiling(totalPages))) + " "
set color to W/
return

****************************
Procedure ShowHelp
*
* Show a help dialog in the list view
*
do Box3D with 6,14,23,66,0
set color to R/W
do Center with 7, "Filer 1.0"
do Center with 8, "By Tony Fardella"
set color to B/W
do Center with 10, "Help"
@11,18 say "Cursor Up/Down     - Previous/Next Line"
@12,18 say "Enter/Cursor Right - Select"
@13,18 say "Cursor Left        - Previous/Back"
@14,18 say ""
@15,18 say "1-9 - Jump    Space - Tag/UnTag"
@16,18 say "T - Top       B - Bottom         M - Move"
@17,18 say "Q - Quit      I - Info           C - Copy"
@18,18 say "D - Download  U - Upload         E - Erase"
@19,18 say "F - Filter    V - View Archive"
set color to R/W
do Center with 21, "Press any key to continue"

wait ""
set color to w/
return

****************************
Procedure GetInfo
Parameters filePath
*
* Display file information including name, size, date and type
*
Private filename

if reccount() = 0
    return
endif

do Box3D with 9,20,19,60,0
set color to R/W
@10,31 say "File Information"
set color to GR/W

filename = substr(filePath,rat("\",filePath) + 1,len(filePath) - rat("\",filePath))
@12,24 say "Name: " + trim(filename)

if substr(LTYPE,2,1) = "X"
	@13,24 say "Size: N/A"
	@14,24 say "Date: N/A"
else
    @13,24 say "Size: " + ltrim(str(fsize(filePath))) + " Bytes"
	@14,24 say "Date: " + dtoc(fdate(filePath))
endif

do case
case substr(LTYPE,2,1) = "X"
	@15,24 say "Type: Directory"
case substr(LTYPE,3,1) = "X"
	@15,24 say "Type: Volume Label"
case substr(LTYPE,4,1) = "X"
	@15,24 say "Type: System File"
endcase

if substr(LTYPE,5,1) = "X"
	@15,42 say " <Hidden>"
endif

set color to B/W
@17,27 say "Press any key to continue"

wait ""
set color to w/
return


******************************
* Get Directory
*
Procedure GetDir
Parameters gdPath
*
* Create a list database from a DOS directory
*

private fName, dta

if file(listdb)
	erase &listdb
endif

scrTitle = crtrim(trim(gdPath))

use
create &listdb from &newstruc
use &listdb

dPath = left(gdPath,rat("\", gdPath))
fName = findfirst(dta, gdPath, "X.XXX", atrb)
do while len(fName) <> 0
    if fName = "." .and. .not. fName=".."
        fName = findnext(dta, atrb)
    else
        append blank
        replace LTEXT with rtrim(fName)
        replace LPATH with rtrim(dPath)
        replace LTYPE with atrb
        replace LTAG with .F.

        fName = findnext(dta, atrb)
    endif
enddo

goto top
curPath = dPath
numRecs = reccount()
totalPages = numRecs/maxLines
pageNum = 0
curLine = 1
tagged = 0
taggedSize = 0
return


*******************************
Procedure UserQuit
*
* Bring up a dialog box asking if the user really wants to quit.
*
do Box3D with 8,18,13,62,0
set color to R/W
@9,37 say "Quit?"
set color to B/W
@11,22 say "Are you sure you want to quit? (Y/N)"
key = inkey(0)
if upper(chr(key)) = "Y"
	uQuit = .T.
endif
set color to w/
return

*******************************
Procedure NotAvail
*
* Inform the user that the current item is not available for downloading.
*
do Box3D with 8,15,15,65,0
set color to R/W
@9,37 say "Sorry"
set color to B/W
@11,18 say "This item is not available for downloading."
@13,27 say "Press any key to continue"
key = inkey(15)
set color to w/
return

*******************************
Procedure FileExist
*
* Inform the user that the already exists and prompt for action.
*
do Box3D with 8,15,15,65,0
set color to R/W
do Center with 9, "File Already Exists"
set color to B/W
do Center with 11, "Would you like to overwrite this file?"
do Center with 13, "<ENTER> Accept            <ESC> Cancel"
do_it = .F.
key = inkey(0)
if key = 13
    do_it = .T.
endif
set color to w/
return

**********************************
* Misc. Procedures
*
* These are various general purpose procedures which can
* be used by any program.
*
* Included are:
*
*       Center      - Center a text string on the screen
*                      written by Tom Faulkner from the book
*                      Tip, Traps and Techniques for TBBS
*
*       Box3D       - Draw a 3D looking ANSI box of any size
*
*       ChkANSI     - Check for ANSI terminal compatibility
*                      I got this procedure off the eSoft BBS. I can't
*                      recall who wrote it, but I thank them.
*
*       ShowError   - Bring up a box showing a TDBS error message
*                      (uses Box3D)
*
*       PleaseWait  - Put up a box asking the user to wait. Used for
*                      operations that will take more than a few seconds.
*                      (uses Box3D)
*
*       LineEdit    - Input a single line of text. Allows for better
*                      control of editing than standard TDBS methods.

********************************
Procedure Center
Parameters nRow, cText
*
* Centers text string on the screen
*
* Input: nRow = screen row
*	 cText = text string
*

Private nCol
nCol = Uwidth() - Len(cText)
nCol = Max(nCol,0)
nCol = nCol / 2
If Uansi()
	@nRow,nCol say cText
else
	? Replicate(" ",nCol) + cText
endif
return

***************************
Procedure Box3D
Parameters orgRow, orgCol,  endRow, endCol, bStyle
*
* Create a "3D" box of the size passed by the input parameters
*
* Input: orgRow, orgCol = starting point
*	 endRow, endCol = ending point
*	 bStyle = Box Style 0 = recessed  1 = extruded
Private nRow

set intensity off
set color to N/W
@orgRow,orgCol say " "
if bStyle = 0
	set color to  N+/W
else
	set color to  W+/W
endif
@orgRow,orgCol+1 say "" + replicate("",(endCol - orgCol) - 4)
if bStyle = 0
	set color to W+/W
else
	set color to  N+/W
endif

@orgRow,endCol-2 say " "
set color to N+/N
@orgRow,endCol say ""

nRow = orgRow + 1
do while nRow < endRow - 1
	set color to N/W
	@nRow,orgCol say " "
	if bStyle = 0
	set color to  N+/W
	else
	set color to  W+/W
	endif
	@nRow,orgCol+1 clear to nRow,endCol
	@nRow,orgCol+1 say ""
	if bStyle = 0
	set color to  W+/W
	else
	set color to  N+/W
	endif
	@nRow,endCol-2 say ""
	set color to N+/N
	@nRow,endCol say ""
	nrow = nRow + 1
enddo

set color to N/W
@endRow-1,orgCol say " "
if bStyle = 0
	set color to  N+/W
else
	set color to  W+/W
endif
@endRow-1,orgCol+1 say ""
if bStyle = 0
	set color to  W+/W
else
	set color to  N+/W
endif
@endRow-1,orgCol+2 say replicate("",(endCol - orgCol) - 4) + " "
set color to N+/N
@endRow-1,endCol say ""

set color to N+/N
@endRow,orgCol say " "  + replicate("",endCol - orgCol)
return

***************************************
Procedure ChkANSI
*
* Check for ANSI compatibility
*
* I got this off the eSoft BBS. I can't remember
* who wrote it, but I thank them.
*
Private TESTANSI, TESTIBM, DUMMY, KEY, TEST

TESTANSI = UANSI()
TESTIBM = UIBMG()

IF .NOT. TESTANSI
	DUMMY = ULREPLACE(UANSI, .T.)
	? CHR(27)+"[0m"
	DUMMY = ULREPLACE(UANSI, .F.)

	CLEAR

	? ""
	? "Testing for ANSI..."
	? ""
	DUMMY = ULREPLACE(UANSI, .T.)
	? CHR(27)+"[0m"+CHR(27)+"[31mC"+CHR(27)+"[33;1mo"+CHR(27)+"[32ml"+CHR(27)+"[34;1mo"+CHR(27)+"[35mr"+CHR(27)+"[0m"
	DUMMY = ULREPLACE(UANSI, .F.)
	? ""
	? "Does the above line look like:"
	? ""
	? "     1 - Unreadable junk"
	? "     2 - Colorful text"
	? "     3 - Monochrome text, some letters brighter than others"
	? ""
	? "Your selection... "
	TEST = "0"
	DO WHILE TEST = "0"
	KEY = INKEY(0)
	TEST = CHR(KEY)
	DO CASE
		CASE TEST = "1"
		? ""
		? "Sorry, this program requires ANSI terminal support."
		? "Press and key to continue..."
		KEY = INKEY(5)
		quit
		CASE TEST = "2"
		? ""
		? "Your settings will be changed so you can see color online."
		? "These changes will take effect on your next call to the system."
		DUMMY = ULREPLACE(UANSI, .T.)
		CASE TEST = "3"
		? ""
		? "Your settings will be changed so you can see bold text online."
		? "These changes will take effect on your next call to the system."
		DUMMY = ULREPLACE(UANSI, .T.)
		OTHERWISE
		TEST = "0"
	ENDCASE
	ENDDO
ENDIF

IF .NOT. TESTIBM
	? ""
	? "Testing for IBM Graphics..."
	? ""
	DUMMY = ULREPLACE(UIBMG, .T.)
	? CHR(176)+CHR(177)+CHR(178)+CHR(219)
	DUMMY = ULREPLACE(UIBMG, .F.)
	? ""
	? "On the above line, do you see:"
	? ""
	? "     1 - The characters '012['"
	? "     2 - Boxes with varying shades"
	? ""
	? "Your selection... "
	TEST = "0"
	DO WHILE TEST = "0"
	KEY = INKEY(0)
	TEST = CHR(KEY)
	DO CASE
		CASE TEST = "1"
		? ""
		? "Your settings will not be changed."
		CASE TEST = "2"
		? ""
		? "Your settings will be changed so you can see color online."
		? "These changes will take effect on your next call to the system."
		DUMMY = ULREPLACE(UIBMG, .T.)
		OTHERWISE
		TEST = "0"
	ENDCASE
	ENDDO
ENDIF

IF TESTANSI .AND. TESTIBM
	? ""
	? "Testing not necessary.  ANSI and IBM Graphics already enabled."
	? "Press any key..."
	KEY = INKEY(5)
ELSE
	? ""
	? "Changes (if any) complete.  Press any key..."
	KEY = INKEY(5)
ENDIF
return

*******************************
Procedure ShowError
*
* Show a dialog with a TDBS error message and the file that created it.
*
Parameters thePath

do Box3D with 8,10,16,70,0
set color to R/W
@9,37 say "Error !"
set color to B/W
@11,13 say "   Error: "+MESSAGE()
@12,13 say "File was: [" + trim(thePath) + "]"
@14,27 say "Press any key to continue"
wait ""
set color to w/
close all
quit

**********************************
Procedure PleaseWait
*
* Display a box on the screen requesting the user to Please Wait.
*
do Box3D with 6,25,9,55,0
set color to B/W
@7,33 say "Please wait..."
set color to w/
do_display = .T.
return

*********************************
Procedure LineEdit
Parameters orgRow, orgCol, endCol
*
* Input a line of text. Requires public variable eText
* be previously declared.
*
* Input: orgRow = Row to start input
*        orgCol = Column to start input
*        endCol = Column for end of input
*        eText = Whatever is in this variable will be put on the screen
*
* Output: eText = edited text
*

set color to W+/N
@orgRow,orgCol clear to orgRow,endCol
@orgRow,orgCol say eText

nRow = orgRow
nCol = orgCol + len(eText)
maxLen = endCol - orgCol

do while .T.
    key = inkey(0)
	if key < 0
        key = 255
	endif

	sel = chr(key)

	do case

	*
	* Right cursor
	*
	case sel = chr(4)
    if nCol < endCol .and. (nCol - orgCol) < len(eText)
		nCol = nCol + 1
		@nRow,nCol say ""
	endif

	*
	* Left Cursor
	*
	case sel = chr(19)
	if nCol > orgCol
		nCol = nCol - 1
		@nRow,nCol say ""
	endif

	*
	* Back space
	*
	case sel = chr(8)
        if nCol > orgCol
            nCol = nCol - 1
        endif
        eText = stuff(eText,(nCol - orgCol)+1,1,"")
        @orgRow,orgCol clear  to orgRow,endCol
        @orgRow,orgCol say eText
        @nRow,nCol say ""

    *
    * Delete
    *
    case sel = chr(127)
        eText = stuff(eText,(nCol - orgCol)+1,1,"")
        @orgRow,orgCol clear  to orgRow,endCol
        @orgRow,orgCol say eText
        @nRow,nCol say ""

    *
    * Return
    *
    case sel = chr(13)
        return

    *
	* Home
	*
    case sel = chr(1)
        nCol = orgCol
        @nRow,nCol say ""

	*
	* End
	*
    case sel = chr(6)
        nCol = orgCol + len(eText)
        if nCol > endCol
            nCol = endCol
        endif
        @nRow,nCol say ""

	*
	* Character
	*
    case sel > chr(31) .and. sel < chr(127)
	@nRow,nCol say sel
    if .not. len(eText) > maxLen
        eText = stuff(eText,(nCol - orgCol)+1,0,sel)
        if nCol < endCol
            nCol = nCol + 1
        endif
    endif
    @orgRow,orgCol say eText
	@nRow,nCol say ""

	*
	* Escape
	*
    case sel = chr(27) .or. key = 0
        eText = ""
        return

	endcase
enddo

return

